<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="会员名称" prop="title">
                    <el-input v-model="formData.title" clearable placeholder="请输入会员名称" :readonly="false"/>
                </el-form-item>
                <el-form-item label="充值金额" prop="limit">
                    <el-input v-model="formData.limit" clearable placeholder="请输入充值金额" :readonly="false"/>
                </el-form-item>
                <el-form-item label="排序倒序" prop="sort">
                    <el-input v-model="formData.sort" clearable placeholder="请输入排序倒序" :readonly="false"/>
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="userShipEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiUserShipAdd, apiUserShipEdit, apiUserShipDetail } from '@/api/user_ship'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑会员类型' : '新增会员类型'
})

// 表单数据
const formData = reactive({
    id: '',
    title: '',
    limit: '',
    sort: '',
})


// 表单验证
const formRules = reactive<any>({
    title: [{
        required: true,
        message: '请输入会员名称',
        trigger: ['blur']
    }],
    limit: [{
        required: true,
        message: '请输入充值金额',
        trigger: ['blur']
    }],
    sort: [{
        required: true,
        message: '请输入排序倒序',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiUserShipDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiUserShipEdit(data) 
        : await apiUserShipAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
